summaryrefslogtreecommitdiff
path: root/plugins/svn-fast-info/svn-fast-info.plugin.zsh
diff options
context:
space:
mode:
authorBrice Dutheil <brice.dutheil@gmail.com>2014-01-06 14:09:40 +0100
committerBrice Dutheil <brice.dutheil@gmail.com>2014-01-06 14:09:40 +0100
commit1304ed8d2521e452615bcf7563700018443f5470 (patch)
treea711f73727761c3eb75db70439b9baa32b7fcf69 /plugins/svn-fast-info/svn-fast-info.plugin.zsh
parent9ce1b6289aebc8e19b8bb25e4f7ac1cbc84e83de (diff)
downloadzsh-1304ed8d2521e452615bcf7563700018443f5470.tar.gz
zsh-1304ed8d2521e452615bcf7563700018443f5470.tar.bz2
zsh-1304ed8d2521e452615bcf7563700018443f5470.zip
Report the SVN need upgrade
This happen when subversion 1.7+ is used on a repository created with subversion up to 1.6
Diffstat (limited to 'plugins/svn-fast-info/svn-fast-info.plugin.zsh')
-rw-r--r--plugins/svn-fast-info/svn-fast-info.plugin.zsh16
1 files changed, 11 insertions, 5 deletions
diff --git a/plugins/svn-fast-info/svn-fast-info.plugin.zsh b/plugins/svn-fast-info/svn-fast-info.plugin.zsh
index d8fc53989..1027bcac2 100644
--- a/plugins/svn-fast-info/svn-fast-info.plugin.zsh
+++ b/plugins/svn-fast-info/svn-fast-info.plugin.zsh
@@ -10,7 +10,7 @@
# *** IMPORTANT *** DO NO USE with the simple svn plugin, this plugin acts as a replacement of it.
function parse_svn() {
- info=$(svn info 2> /dev/null) || return
+ info=$(svn info 2>&1) || return; # capture stdout and stdout
in_svn=true
repo_need_upgrade="$(svn_repo_need_upgrade $info)"
svn_branch_name="$(svn_get_branch_name $info)"
@@ -22,7 +22,13 @@ function parse_svn() {
function svn_prompt_info() {
eval parse_svn
- if [ ${in_svn} ]; then
+ if [ ! -z $repo_need_upgrade ]; then
+ echo $ZSH_PROMPT_BASE_COLOR$ZSH_THEME_SVN_PROMPT_PREFIX$ZSH_PROMPT_BASE_COLOR\
+$repo_need_upgrade\
+$ZSH_PROMPT_BASE_COLOR$ZSH_THEME_SVN_PROMPT_SUFFIX$ZSH_PROMPT_BASE_COLOR
+ fi
+
+ if [[ ${in_svn} == true && -z $repo_need_upgrade ]]; then
echo "$ZSH_PROMPT_BASE_COLOR$ZSH_THEME_SVN_PROMPT_PREFIX\
$ZSH_THEME_REPO_NAME_COLOR${svn_branch_name}\
$ZSH_PROMPT_BASE_COLOR${svn_dirty}\
@@ -34,8 +40,8 @@ $ZSH_PROMPT_BASE_COLOR"
function svn_repo_need_upgrade() {
info=$1
- [ -z "${info}" ] && info=$(svn info 2> /dev/null)
- [ "${info}" = "E155036" ] && echo "upgrade repo with svn upgrade"
+ [ -z "${info}" ] && info=$(svn info 2>&1)
+ if grep -q "E155036" <<< $info; then echo "E155036: upgrade repo with svn upgrade"; fi
}
function svn_get_branch_name() {
@@ -61,4 +67,4 @@ function svn_get_revision() {
function svn_dirty_choose() {
svn status | grep -E '^\s*[ACDIM!?L]' > /dev/null 2>/dev/null && echo $ZSH_THEME_SVN_PROMPT_DIRTY && return
echo $ZSH_THEME_SVN_PROMPT_CLEAN
-} \ No newline at end of file
+}